function deepCopy(tab)
    local copy
    if type(tab) == 'table' then
        copy = {}
        for key, value in next, tab, nil do
            copy[deepCopy(key)] = deepCopy(value)
        end
        setmetatable(copy, deepCopy(getmetatable(tab)))
    else
        copy = tab
    end
    return copy
end

--Never use (io.read(filename) ~= nil) !
--It will open the file, but won't close it
--Thus forbidding you from moving/renaming it!
function fileExists(filename)
	local exists = io.open(filename)
	if(exists ~= nil) then
		exists:close()
		return true
	end
	return false
end

function parseLine(line)
	local out = {}
	for word in string.gmatch(line, "%S+") do
		table.insert(out,word)
	end
	return out
end

function trim(str,char)
	if(char == nil) then
		char = " "
	end
	local trimL = 1
	local trimR = #str
	local c = 1
	while c < #str do
		if(str:sub(c,c + #char - 1) == char) then
			trimL = trimL + 1
			c = c + 1
		else
			c = #str
		end
	end
	while c > 0 do
		if(str:sub(c - #char + 1,c) == char) then
			trimR = trimR - 1
			c = c - 1
		else
			c = 0
		end
	end
	str = str:sub(trimL,trimR)
	return str
end
